The Fish-Tank Game
==================

This was made to be read slowly, like a security-focussed man page with all the POSIX-compatibility flags removed.

The scattered notes just add detail, so you can scan or ignore them.

Stage 1: Popular Populations
----------------------------

This cavern has snake-like tunnels stretching a long way, which open into a large empty, space.
Sometimes these spaces have an underground river, or a lake.
Three kinds of creatures live here:

- Moss takes energy from the moisture in the air, and loves the moisture by any river or lake.
    * When the moss is crushed by feet, it becomes annoyed, and starts to burn anything touching it.  Sticks and rocks will not hurt it.
- Goblins want to sit by the water, and fish.  Sometimes they have a wedding and goblins children, but most of the time, there is too much burning moss to get near the river.
    * When goblins find an ooze, they want to smash it to pieces and eat the little blobs.
- That semi-sentient, ooze, wanders through the tunnels.  If it finds another ooze, the two join together into a massive blob, but when goblins smash the ooze, it scatters into little pieces, which slither away.
    * The ooze slowly eats the moss, whenever it gets some peace and quiet.

Stage 2: Watching the Tank
--------------------------

You see these three just as basic blobs on the screen - red-moss patches, green ooze, and little white goblins.
You zoom out, and see the entire cavern fighting constantly.

Like rock, paper, scissors, nobody can win.

- When the ooze grows too big, goblins feast on it, and mate by the rivers and lakes; but if the ooze is smashed apart, small pieces will slide away, and the moss will grow so large that the goblins will have nowhere to run, until the ooze starts feeding.
- Too much moss means that any ooze pieces have lots of food, but if the moss is mostly gone, then the goblins will have nothing to eat at the feasts by the lakes and rivers.

The environment is self-righting, up to a point.
You can watch the ecosystem play out like a fish-tank.

Stage 3: Sprite Sprint
----------------------

The player's sprite arrives, finally, and they want to leave this strange cave.
They have no idea how the whole cavern looks.

- The sprite can grab lots of moss, if they're careful.  It stops goblins following, and the ooze will follow them if there is no other moss.
- The goblins will kill the player's sprite, and eat them, if there is no ooze about to eat.
- The ooze can suffocate anyone who is alone, so the sprite should avoid dead-end tunnels.

The terrain has a few oddities too:

- Rivers are deadly if the sprite goes inside.
- The sprite can swim across lakes easily, and the goblins will never follow.
- However, any ooze in a lake will kill you by suffocation - you will see it coming, and when it catches you, death.

Cavern Depth
============

That's the core-concept; you watch an ecosystem fight, and plan how to mess with it, one chamber at a time.
Sometimes the player must run back and find a new route.
A lot of the time, the player can guess what's up a tunnel, just by what goes in and out.

The world is order, [the player is chaos](World/Players_are_Entropy.md).

Layers
------

This is a toy example with 3 moving pieces, but we could have more:

- A second ecosystem, which never touches the first directly, but dominates space in its own way.
- Two more creatures -- each of them hurts two, and is hurt by two.
- More static environmental conditions, such as shafts of light which hurt some creatures.
- Glowing mushrooms provide light, but light lets non-blind creatures see and attack you.
    * If the ooze eats the glowing mushrooms, it glows.
- Diamorphism: goblins and oozes could grow differently, depending on what they eat.  This could grow into a new self-righting mechanism.
- Each ecosystem could have its own pacing, for example:
    * Gas vents, fireflies, and gnomish vent-patchers work quickly.
    * Goblins, oozes, and moss go at medium-speed.
    * The wyrms that eat to make new tunnels, the large insects, and cave-ins work so slowly, you only see a little movement over the course of a full game.

Graphics
--------

Something like the early Legend of Zelda, but with vector graphics, and plenty of randomization to change how goblins look. 

Principles
----------

1. The puzzles have no solutions, but they do have lots of levers.
1. Everything has a natural balance, but destroying part of the ecosystem is possible.
1. Everything is a general property.
    * Goblins don't just eat ooze - they eat anything medium-sized which they can hit.
    * Some creatures have ears, others have eyes.  But you can't look out for light when a lot of light is blinding you.
    * Everything is stupid, but most things are not suicidal - if the player's cunning plan is destroying goblins, they will retreat.
1. Nothing has omniscience.  Each thing makes its own decisions.
    * Nothing goes towards the player, or each other.
    * Oozes wander blind.
    * Goblins swap information about the tunnels they have been down.  When the population is large, they begin to lie to kill each other and horde food.
    * None of these decisions needs to be made at a particular time, so multi-threading may not pose a massive problem.

